package net.moonleay.etaorion.client.modules.component

import net.minecraft.client.MinecraftClient


open class Module(val name: String, val category: Category) {
    protected val mc = MinecraftClient.getInstance()
    open var enabled = false
    open var listIndex = 0

    open fun onTick() {}

    open fun onClientShutdown() {}

    open fun onLoad(enabled: Boolean) {
        this.enabled = enabled
        ModuleManager.toggleModule(this, enabled)
        onToggleEnabled(enabled)
    }

    open fun updateEnabled(enabled: Boolean) {
        this.enabled = enabled
        onToggleEnabled(enabled)
    }

    open fun onToggleEnabled(enabled: Boolean) {}

    open fun onEventPre() {}
}
