package net.moonleay.etaorion.client.screen

import net.minecraft.client.MinecraftClient
import net.minecraft.client.gui.DrawContext
import net.minecraft.client.gui.screen.Screen
import net.minecraft.client.gui.widget.ButtonWidget
import net.minecraft.client.gui.widget.TextFieldWidget
import net.minecraft.screen.ScreenTexts
import net.minecraft.text.Text
import net.moonleay.etaorion.client.autotext.AutoText
import net.moonleay.etaorion.client.autotext.AutoTextManager
import net.moonleay.etaorion.client.autotext.KeyBindingManager
import net.moonleay.etaorion.client.modules.component.ModuleManager
import net.moonleay.etaorion.config.AutoTextConfig
import org.lwjgl.glfw.GLFW


class AutoTextScreen(val parent: Screen) : Screen(Text.of("AutoText Manager")) {
    private var optionList: AutoTextWidget? = null
    private var addressField:TextFieldWidget? = null


    override fun init() {
        optionList = AutoTextWidget(this, client!!)
        addSelectableChild(optionList)
        addressField =
            TextFieldWidget(textRenderer, 4, height - 25, 200, 20, Text.of("Add new AutoText"))
        addressField!!.setMaxLength(300)
        addSelectableChild(addressField)
        addDrawableChild(
            ButtonWidget.builder(
                Text.of("Add")
            ) { addText() }
                .dimensions(210, height - 25, 40, 20).build())

        addDrawableChild(
            ButtonWidget.builder(
                ScreenTexts.DONE
            ) { onClose() }
                .dimensions(250, height - 25, 40, 20).build())
    }

    private fun addText(){
        val keyBinding = KeyBindingManager.bookKeyBinding()?: return
        val response = AutoTextManager.registerNewAutoTxtObject(AutoText(addressField!!.text, keyBinding))
        if(response){
            addressField!!.setText("")
            this.client?.setScreen(this)
        }
    }

    override fun close() {
        onClose()
        super.close()
    }

    override fun shouldCloseOnEsc(): Boolean {
        return false
    }

    fun onClose() {
        for(at in AutoTextManager.autoTextObjects){
            AutoTextConfig.save(at)
        }
        client!!.setScreen(parent)
        MinecraftClient.getInstance().setScreen(parent)
    }


    override fun tick() {
//        addressField!!.tick()
    }

    override fun keyPressed(keyCode: Int, scanCode: Int, modifiers: Int): Boolean {
        if (this.addressField!!.active && focused === addressField && (keyCode == GLFW.GLFW_KEY_ENTER || keyCode == GLFW.GLFW_KEY_KP_ENTER)) {
            return true
        }
        return super.keyPressed(keyCode, scanCode, modifiers)
    }

    override fun resize(client: MinecraftClient?, width: Int, height: Int) {
        val string = addressField!!.text
        this.init(client, width, height)
        addressField!!.setText(string)
    }


    override fun render(context: DrawContext?, mouseX: Int, mouseY: Int, delta: Float) {
        // this.renderBackground(context)
        optionList!!.render(context, mouseX, mouseY, delta)
        context?.drawCenteredTextWithShadow(
            textRenderer,
            title,
            width / 2,
            8,
            0xFFFFFF
        )
        addressField!!.render(context, mouseX, mouseY, delta)
        super.render(context, mouseX, mouseY, delta)
    }

}
