package net.moonleay.etaorion.client.screen

import net.moonleay.etaorion.client.modules.component.ModuleManager
import net.minecraft.client.MinecraftClient
import net.minecraft.client.gui.DrawContext
import net.minecraft.client.gui.screen.Screen
import net.minecraft.client.gui.widget.ButtonWidget
import net.minecraft.screen.ScreenTexts
import net.minecraft.text.Text


class OptionScreen(val parent: Screen) : Screen(Text.of("EtaOrion Fabric Options")) {
    private var optionList: ModuleOptionWidget? = null


    override fun init() {
        optionList = ModuleOptionWidget(this, client!!)
        addSelectableChild(optionList)
        addDrawableChild(
            ButtonWidget.builder(
                ScreenTexts.DONE
            ) { onClose() }
                .dimensions(width / 2 - 100, height - 25, 200, 20).build())
    }

    override fun close() {
        onClose()
        super.close()
    }

    override fun shouldCloseOnEsc(): Boolean {
        return false
    }

    private fun onClose() {
        client!!.setScreen(parent)
        ModuleManager.saveAllModules()
        MinecraftClient.getInstance().setScreen(parent)
    }

    override fun render(context: DrawContext, mouseX: Int, mouseY: Int, delta: Float) {
        this.renderBackground(context, mouseX, mouseY, delta)
        //drawCenteredText(matrices, this.textRenderer, this.title, this.width / 2, 15, 0xFFFFFF);
        optionList!!.render(context, mouseX, mouseY, delta)
        context?.drawCenteredTextWithShadow(
            textRenderer,
            title,
            width / 2,
            8,
            0xFFFFFF
        )
        super.render(context, mouseX, mouseY, delta)
    }

}
