package net.moonleay.etaorion.mixin;

import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.screen.ChatScreen;
import net.minecraft.client.gui.screen.Screen;
import net.minecraft.client.gui.screen.option.KeybindsScreen;
import net.minecraft.client.gui.widget.ButtonWidget;
import net.minecraft.text.Text;
import net.moonleay.etaorion.client.screen.AutoTextScreen;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(ChatScreen.class)
public class AddAutoTextScreenButton extends Screen {
    protected AddAutoTextScreenButton(Text title) {
        super(title);
    }

    @Inject(method = "init", at = @At("HEAD"), cancellable = true)
    public void addButtons(CallbackInfo ci) {
        this.addDrawableChild(ButtonWidget.builder(Text.of("AutoText"), button -> this.client.setScreen(new AutoTextScreen(this))).dimensions(4, 4, 75, 20).build());
        this.addDrawableChild(ButtonWidget.builder(Text.of("Key Binds"), button -> this.client.setScreen(new KeybindsScreen(this, MinecraftClient.getInstance().options))).dimensions(4, 25, 75, 20).build());
    }
}
