package net.moonleay.etaorion.mixin;

import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.screen.ChatScreen;
import net.minecraft.text.Text;
import net.moonleay.etaorion.client.modules.component.ModuleStorage;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(ChatScreen.class)
public abstract class ChatMixin {
    private Logger lgr = LogManager.getLogger(ChatMixin.class);

    @Inject(method = "sendMessage", at = @At("HEAD"), cancellable = true)
    public void checkForFatFinger(String chatText, boolean addToHistory, CallbackInfoReturnable<Boolean> cir) {
        if(ModuleStorage.INSTANCE.getAntiFatFingerEnabled() && (chatText.startsWith(".") || chatText.startsWith("7")) && !chatText.startsWith("./")){
            cir.setReturnValue(false);
            cir.cancel();
            MinecraftClient.getInstance().player.sendMessage(Text.of("§cMessage cancelled, was fat-fingered."), false);
            lgr.info("Message cancelled, was fat-fingered.");
        }
    }
}
