package net.moonleay.etaorion.mixin;

import net.minecraft.SharedConstants;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(SharedConstants.class)
public class LazyDFUMixin {
    /**
     * author: Andrew Steinborn
     * reason: Disables any possibility of enabling DFU "optimizations"
     * (This was edited)
     */
    private static final Logger lgr = LogManager.getLogger("LazyDFUMixin");
    @Inject(method = "enableDataFixerOptimization", at = @At("HEAD"), cancellable = true)
    private static void enableDataFixerOptimizations(CallbackInfo ci) {
        lgr.info("LazyDFU: skipping DFU");
        ci.cancel();
        // Turn this method into a no-op.
    }
}
